# MerlinOne DAM Integration #

## INTRODUCTION ##

The MerlinOne module enables searching for and importing managed files and Media
entities from the MerlinOne DAM using Entity Browser.

## REQUIREMENTS ##

For managed files or the Media Image provider:

 * [Entity Browser](https://www.drupal.org/project/entity_browser)
 * [Media entity image](https://www.drupal.org/project/media_entity_image) (dev
   release currently required)
 * [Media entity](https://www.drupal.org/project/media_entity) (dev release
   currently required)

For the Media Document provider:

 * MerlinOne Document (included)
 * [Media entity document](https://www.drupal.org/project/media_entity_document)

## Recommended Modules ##

 * [Media Entity Browser](https://www.drupal.org/project/media_entity_browser)
   for Media Entity browsing and previews
 * [Entity Embed](https://www.drupal.org/project/entity_embed) to embed media
   entities within content

## INSTALLATION ##

 * Install as you would normally install a contributed Drupal module.
   See: https://www.drupal.org/node/895232 for further information.

## CONFIGURATION ##

As a first step after installation you must configure the location of your
Merlin MX system at
Administration > Configuration > Web Services > MerlinOne Settings
(/admin/config/services/merlinone).

Once you have done this, create a Media Bundle using the MerlinOne Image type
provider (or the MerlinOne Document provider if you are using MerlinOne
Document). The only required field in that bundle is an Image (or File for a
document) field that must be set as the Source image for the bundle. You can
also create optional metadata fields and map them to fields that will be filled
with content from the MerlinOne DAM when you do an import.

You can import assets from Merlin using an Entity Browser widget. Once the
bundle is created, add either a MerlinOne Search (for managed files) or a Media
Entity MerlinOne Search (for Media entities) widget to an Entity Browser
configuration.

In the configuration for the Entity Browser module we recommend configuring the
Entity Browser setting for Display plugin to iFrame, and on the next page of the
configuration set the Width of the iFrame to 900 and height to 700 initially.

You can find additional information on using and configuring the Media module in
the [Drupal 8 Media
Guide](https://www.gitbook.com/book/drupal-media/drupal8-guide/details).

## Usage ##

After you log in through the MerlinOne Entity Browser widget. To select an asset
assets, single-click on it. You can bring up the large screen view by
double-clicking. After making your selections, click the "Select entities"
button at the bottom of the panel. Once that button is Drupal will import the
items from Merlin and placed in the Media Library and insert them into the
content.
