<?php

namespace Drupal\merlinone_document\Plugin\MediaEntity\Type;

use Drupal\media_entity\MediaInterface;
use Drupal\media_entity_document\Plugin\MediaEntity\Type\Document;
use Drupal\merlinone\Traits\MerlinOneMediaTypeTrait;

/**
 * Provides a document media type plugin for MerlinOne.
 *
 * @MediaType(
 *   id = "media_merlinone_document",
 *   label = @Translation("MerlinOne Document"),
 *   description = @Translation("MerlinOne document media type")
 * )
 */
class MediaMerlinOneDocument extends Document {

  use MerlinOneMediaTypeTrait;

  /**
   * {@inheritdoc}
   */
  public function providedFields() {
    return $this->getProvidedFields() + parent::providedFields();
  }

  /**
   * {@inheritdoc}
   */
  public function getField(MediaInterface $media, $name) {
    // Get base Document field.
    $value = parent::getField($media, $name);
    if ($value) {
      return $value;
    }

    return $this->getMerlinField($media, $name);
  }

  /**
   * {@inheritdoc}
   */
  protected function getEntityTypeManager() {
    return $this->entityTypeManager;
  }

}
