<?php

namespace Drupal\merlinone\Plugin\MediaEntity\Type;

use Drupal\media_entity\MediaInterface;
use Drupal\media_entity_image\Plugin\MediaEntity\Type\Image;
use Drupal\merlinone\Traits\MerlinOneMediaTypeTrait;

/**
 * Provides a media type plugin for MerlinOne.
 *
 * @MediaType(
 *   id = "media_merlinone_image",
 *   label = @Translation("MerlinOne Image"),
 *   description = @Translation("MerlinOne image media type")
 * )
 */
class MediaMerlinOneImage extends Image {

  use MerlinOneMediaTypeTrait;

  /**
   * {@inheritdoc}
   */
  public function providedFields() {
    return $this->getProvidedFields() + parent::providedFields();
  }

  /**
   * {@inheritdoc}
   */
  public function getField(MediaInterface $media, $name) {
    // Get base Image field.
    $value = parent::getField($media, $name);
    if ($value) {
      return $value;
    }

    return $this->getMerlinField($media, $name);
  }

  /**
   * {@inheritdoc}
   */
  protected function getEntityTypeManager() {
    return $this->entityTypeManager;
  }

}
